<?php
function xf_publish_post($postId, $post) {
	$xf = XenForo_WP::create();
	$xfUserId = $xf->getUserId();
	if ($xfUserId > 0) {
		// we have to check for existed news feed item
		// this query should be fast because the table's indexed
		$existed = $xf->xfdb->get_row("
			SELECT news_feed_id
			FROM xf_news_feed
			WHERE content_type = 'bdwpp_post' AND content_id = {$post->ID}
		");
		
		if (empty($existed)) {
			$post->post_link = xf_get_permalink($post->ID);
			
			// nothing yet, it's time for us
			$xf->xfdb->insert('xf_news_feed', array(
				'user_id' => $xfUserId,
				'username' => $xf->getUserInfo('username'),
				'content_type' => 'bdwpp_post',
				'content_id' => $post->ID,
				'action' => 'publish',
				'event_date' => time(),
				'extra_data' => serialize($post),
			));
		}
	}
}
add_action('publish_post', 'xf_publish_post', 10, 2);


function xf_comment_post($commentId, $approved) {
	if ($approved) {
		$comment = get_comment($commentId);
		if (!empty($comment)) {
			$xf = XenForo_WP::create();
			$xfUserId = $xf->getUserId();
			$xfUsername = $xf->getUserInfo('username');
			if ($xfUserId > 0 AND $xfUsername == $comment->comment_author) {
				// we have to check for existed news feed item
				// this query should be fast because the table's indexed
				$existed = $xf->xfdb->get_row("
					SELECT news_feed_id
					FROM xf_news_feed
					WHERE content_type = 'bdwpp_comment' AND content_id = {$comment->comment_ID}
				");
				
				if (empty($existed)) {
					$post = get_post($comment->comment_post_ID);
					$comment->post_title = $post->post_title; 
					// TODO: Do something to save the above query :( PLEASE!
					$comment->post_link = xf_get_permalink($post->ID);
					
					// nothing yet, it's time for us
					$xf->xfdb->insert('xf_news_feed', array(
						'user_id' => $xfUserId,
						'username' => $xfUsername,
						'content_type' => 'bdwpp_comment',
						'content_id' => $comment->comment_ID,
						'action' => 'approved',
						'event_date' => time(),
						'extra_data' => serialize($comment),
					));
				}
			}
		}
	} else {
		// do nothing with unapproved comment
	}
}
add_action('comment_post', 'xf_comment_post', 10, 2);

function xf_set_comment_status($commentId, $commentStatus) {
	if ($commentStatus == 'approve') {
		// great, we got an approved comment
		// call our sister function to handle it
		xf_comment_post($commentId, true);
	}
}
add_action('wp_set_comment_status', 'xf_set_comment_status', 10, 2);