<?php
function xf_stylesheet_directory($path) {
	if (!defined('XF_ORIGINAL_STYLESHEETPATH')) define('XF_ORIGINAL_STYLESHEETPATH', $path);
	return dirname(__FILE__) . '/theme';
}
add_filter('stylesheet_directory','xf_stylesheet_directory');

function xf_comments_array($comments) {
	$usernames = array();
	$users = array();
	$wp_user_id = wp_get_current_user()->ID;
	$xf_user = XenForo_Visitor::getInstance()->toArray();
	foreach ($comments as &$comment) {
		if ($comment->user_id) {
			if ($comment->user_id == $wp_user_id) {
				$comment->xf_user = $xf_user;
			} else {
				$usernames[$comment->user_id] = $comment->comment_author;
			}
		}
	}
	if (!empty($usernames)) {
		$db = XenForo_Application::get('db');
		$usersRaw = $db->fetchAll('
			SELECT user.*
			FROM xf_user AS user
			WHERE user.username IN (' . $db->quote($usernames) . ')
		');
		$users = array();
		for ($i = 0; $i < count($usersRaw); $i++) {
			$users[$usersRaw[$i]['username']] =& $usersRaw[$i];
		}
		foreach ($comments as &$comment) {
			if ($comment->user_id AND empty($comment->xf_user) AND isset($users[$comment->comment_author])) {
				$comment->xf_user = $users[$comment->comment_author];
			}
		}
	}

	return $comments;
}
add_filter('comments_array','xf_comments_array');

function xf_comment_form_before() {
	bdWordPressProxy_TemplateHelper::addCss('quick_reply');
	echo '<div class="quickReply message">';
	xf_user_info(XenForo_WP::create()->getUserInfo());
}
add_action('comment_form_before', 'xf_comment_form_before');

function xf_comment_form_after() {
	echo '</div><!-- .quickReply.message -->';
}
add_action('comment_form_after', 'xf_comment_form_after');

function xf_comment_form_defaults($defaults) {
	$defaults['must_log_in'] = '';
	$defaults['logged_in_as'] = '';
	$defaults['comment_notes_before'] = '';
	$defaults['comment_notes_after'] = '';
	$defaults['title_reply'] = '';
	$defaults['title_reply_to'] = '';
	$defaults['comment_field'] = bdWordPressProxy_TemplateHelper::prepare('XenForo_ViewPublic_Helper_Editor::getQuickReplyEditor',array(
		bdWordPressProxy_TemplateHelper::View(),
		'comment',
	));
	$defaults['id_form'] = 'QuickReply';
	
	return $defaults;
}
add_filter('comment_form_defaults', 'xf_comment_form_defaults');